# SHAPE.R
# R functions for elliptic Fourier analysis
# ȉ~t[G͂̂R֐
# 2003.8.2 Hiroyoshi IWATA
# ver.0.8
# copyright 2003 Hiroyoshi IWATA

pca.efdata <- function(data) 
{
	# ȉ~t[GLqq̎听
	# ӁFa1, b1, c1͒萔i1, 0, 0jƉ肵ĂI
	dmat <- as.matrix(data[,4:80])
	res <- pca(dmat)
	list(mean=res$mean, var=res$var, sd=res$sd, cv=res$cv, eval=res$eval, evec=res$evec, contr=res$contr, cum.contr=res$cum.contr, score=res$score)
}

pca <- function(dmat)
{
	# 听
	nr <- nrow(dmat)
	nc <- ncol(dmat)
	heikin <- apply(dmat, 2, mean)
	bunsan <- apply(dmat, 2, var)
	sd <- sqrt(bunsan)
	eval <- (result <- eigen(cv <-cov(dmat)))$values
	evec <- result$vectors
	cum.contr <- cumsum(contr <- eval/sum(eval)*100)
	score <- sweep(dmat, 2, heikin)%*%evec

	names(heikin) <- names(bunsan) <- names(sd) <- rownames(cv) <- colnames(cv) <- paste("Var", 1:nc)
	names(eval) <- names(contr) <- names(cum.contr)  <- colnames(score) <- paste("PC", 1:nc)
	list(mean=heikin, var=bunsan, sd=sd, cv=cv, eval=eval, evec=evec, contr=contr, cum.contr=cum.contr, score=score)
}

draw.pc <- function(res, unit=2) {
	# 听֊s̍č\z
	nmax <- length(res$mean)
	n <- 1
	select <- 2  # ׂĂ̋Ȑ
	efm <- pc2efm(res, n, unit)
	draw.efm(efm, main=paste("PC", n))
	while(TRUE) {
		pick <- menu(c("next", "back", "minus", "mean", "plus", "end"))
		if(pick == 1) {
			n <- n + 1
			select <- 2
			if(n == nmax + 1)
				n = nmax
		}
		if(pick == 2) {
			n <- n - 1
			select <- 2
			if(n == 0)
				n = 1
		}
		if(pick == 3)
			select <- -1
		if(pick == 4)
			select <- 0
		if(pick == 5)
			select <- 1
		if(pick == 6)
			break
		if(select == 2) {
			efm <- pc2efm(res, n, unit)
			draw.efm(efm, main=paste("PC", n))
		} else {
			efv <- pc2efv(res, n, unit * select)
			draw.efv(efv, main=paste("PC", n), sub=paste(select*unit, "SD"))
		}
	}
}

pc2efv <- function(res, pc, unit)
{
	# 听͌ʂȉ~t[GLqq𓾂
	# ӁFa1, b1, c1͒萔i1, 0, 0jƉ肵ĂI
	if(pc < 1 || pc > length(res$mean))
		stop("# pc is out of range")
	vec <- rep(0, len=length(res$mean))
	vec[pc] <- unit*sqrt(res$eval[pc])
	vec <- vec%*%t(res$evec) + res$mean
	c(1, 0, 0, vec)
}

pc2efm <- function(res, pc, unit)
{
	# efv𑩂˂čsɂ
	efm <- pc2efv(res, pc, -1*unit)
	efm <- cbind(efm, pc2efv(res, pc, 0))
	efm <- cbind(efm, pc2efv(res, pc, unit))
	efm
}

efv2coord <- function(efv, harmo=0, points=100)
{
	# ȉ~t[GLqqxNgƂē͂A֊sW𓾂
	mat <- matrix(efv, 4)
	if(harmo==0)
		harmo <- length(mat[1,])
	t <- seq(0, 2 * pi, 2 * pi / (points - 1))
	x <- rep(0, points)
	y <- rep(0, points)
	for(i in 1:points) {
		for(j in 1:min(length(mat[1,]),harmo)) {
			x[i] <- x[i] + mat[1,j] * cos(j * t[i]) + mat[2,j] * sin(j * t[i])
			y[i] <- y[i] + mat[3,j] * cos(j * t[i]) + mat[4,j] * sin(j * t[i])
		}
	}
	list(x=x, y=y)
}

draw.efdata <- function(data, harmo=0, points=100, col=1, axes=T) 
{
	# ȉ~t[GLqqf[^̒\
	mat <- as.matrix(data)
	n <- 1
	draw.efv(mat[n,], harmo=harmo, points=points, col=col, axes=axes, main=row.names(data)[n])
	while(TRUE) {
		pick <- menu(c("next", "back", "end"))
		if(pick == 1) {
			n <- n + 1
			if(n == nrow(data) + 1)
				n = nrow(data)
		}
		if(pick == 2) {
			n <- n - 1
			if(n == 0)
				n = 1
		}
		if(pick == 3)
			break
		draw.efv(mat[n,], harmo=harmo, points=points, col=col, axes=axes, main=row.names(data)[n])
	}
}

draw.efv <- function(efv, harmo=0, points=100, col=1, axes=T, main="", sub="")
{
	# ȉ~t[GLqqxNgƂē͂A֊s`
	cont <- efv2coord(efv, harmo, points)
	range = c(min(cont$x, cont$y), max(cont$x, cont$y))
	plot(cont$x, cont$y, xlim=range, ylim=range,type="l", col=col, axes=axes, xlab="", ylab="", main=main, sub=sub)
}

draw.efm <- function(a, harmo=0, points=100, col=1, axes=T, main="")
{
	# ̋LqqxNgičsƂȂj֊s`
	ncont <- ncol(a)
	cont <- efv2coord(a[,1], harmo, points)
	x <- cont$x
	y <- cont$y
	for(i in 2:ncont) {
		cont <- efv2coord(a[,i], harmo, points)
		x <- cbind(x, cont$x)
		y <- cbind(y, cont$y)
	}
	range = c(min(x, y), max(x, y))
	matplot(x, y, xlim=range, ylim=range, type="l", col=col, axes=axes, xlab="", ylab="", main=main)
}

read.chc <- function(file)
{
	# (read.tableœǂݍ߂Ȃ)chcf[^ǂݍނ߂̊֐
	template <- list(name="", chc="")
	temp <- scan(file, template, sep="\t")
	chcdata <- data.frame(chc=I(temp$chc), row.names=temp$name)
	chcdata
}

ef2efv <- function(ef)
{
	# efIuWFNgxNg`efvɕϊ
	harmo <- length(ef$a)
	if(length(ef$b) != harmo || length(ef$c) != harmo || length(ef$d) != harmo)
		stop("# coefficients is not identical")
	mat <- rbind(ef$a, ef$b, ef$c, ef$d)
	efv <- c(mat)
	efv
}

efv2ef <- function(efv)
{
	# xNg`efvefIuWFNgɕϊ
	mat <- matrix(efv, 4)
	a <- mat[1,]
	b <- mat[2,]
	c <- mat[3,]
	d <- mat[4,]
	list(a = a, b = b, c = c, d = d)
}

chc2nef.chcdata <- function(chcdata, harmo=20, points=100, col=1, axes=T)
{
	# ȉ~t[GLqq̒vZ
	mat <- matrix(0,nrow(chcdata),harmo*4)
	colnames(mat) <- paste(matrix(rep(letters[1:4],20),4), t(matrix(rep(1:20,4),20)), sep="")
	rownames(mat) <- rownames(chcdata)
	n <- 1
	nmax <- 1
	nef <- chc2nef(chcdata$chc[n], harmo=harmo)
	while(TRUE) {
		draw.efv((nefv<-ef2efv(nef)), harmo=harmo, points=points, col=col, axes=axes, main=row.names(chcdata)[n])
		mat[n,] <- nefv
		pick <- menu(c("next", "back", "turn", "end"))
		if(pick == 1) {
			n <- n + 1
			if(n == nrow(chcdata) + 1)
				n = nrow(chcdata)
			else
				nef <- chc2nef(chcdata$chc[n], harmo=harmo)
			nmax <- max(n, nmax)
		}
		if(pick == 2) {
			n <- n - 1
			if(n == 0)
				n = 1
			else
				nef <- chc2nef(chcdata$chc[n], harmo=harmo)
		}
		if(pick == 3)
			nef <- turn(nef)
		if(pick == 4)
			break
	}
	efdata <- data.frame(mat <- mat[1:nmax,])
}

chc2nef <- function(chc, harmo=20)
{
	# `F[R[hȉ~t[GLqq߂
	nef <- ef2nef(xyt2ef(chc2xyt(chc), harmo=harmo))
	nef
}

chc2xyt <- function(chc)
{
	# `F[R[hf[^W߂
	# R[hłchcxytIuWFNgɕϊ
	len <- nchar(chc)
	x <- rep(0, len + 1)
	y <- rep(0, len + 1)
	t <- rep(0, len + 1)
	x[1] <- y[1] <- t[1] <- 0
	for(i in 1:len) {
		code = switch(substring(chc, i, i),
			"0" = 0,
			"1" = 1,
			"2" = 2,
			"3" = 3,
			"4" = 4,
			"5" = 5,
			"6" = 6,
			"7" = 7,
			stop("Invalid code"))
		t[i + 1] <- t[i] + 1 + 0.5 * (sqrt(2) - 1) * (1 - (-1)^code)
		x[i + 1] <- x[i] + sign(6 - code) * sign(2 - code)
		y[i + 1] <- y[i] + sign(4 - code) * sign(code)
	}
	list(x = x, y = y, t = t)
}

xyt2ef <- function(xyt, harmo=20)
{
	# W񂩂ȉ~t[GLqq߂
	# xytIuWFNgefIuWFNg߂
	len <- length(xyt$x)
	if(length(xyt$y) != len || length(xyt$t) != len)
		stop ("# of arrays are not identical")
	a <- rep(0, harmo)
	b <- rep(0, harmo)
	c <- rep(0, harmo)
	d <- rep(0, harmo)
	tt <- xyt$t[len]
	dx <- diff(xyt$x)
	dy <- diff(xyt$y)
	dt <- diff(xyt$t)
	for(i in 1:harmo) {
		dcost <- diff(cos(2 * i * pi * xyt$t / tt))
		dsint <- diff(sin(2 * i * pi * xyt$t / tt))
		a[i] <- ((dx/dt) %*% dcost) * (tt / (2 * i * i * pi * pi))
		b[i] <- ((dx/dt) %*% dsint) * (tt / (2 * i * i * pi * pi))
		c[i] <- ((dy/dt) %*% dcost) * (tt / (2 * i * i * pi * pi))
		d[i] <- ((dy/dt) %*% dsint) * (tt / (2 * i * i * pi * pi))
	}
	list(a = a, b = b, c = c, d = d)
}

ef2nef <- function(ef)
{
	# Lqq̕W
	harmo <- length(ef$a)
	if(length(ef$b) != harmo || length(ef$c) != harmo || length(ef$d) != harmo)
		stop("# of coefficients are not identical")
	a <- ef$a
	b <- ef$b
	c <- ef$c
	d <- ef$d
	na <- rep(0, harmo)
	nb <- rep(0, harmo)
	nc <- rep(0, harmo)
	nd <- rep(0, harmo)
	theta <- 0.5 * atan(2 * (a[1] * b[1] + c[1] * d[1]) / (a[1]^2 + c[1]^2 - b[1]^2 - d[1]^2))
	a1 <- a[1] * cos(theta) + b[1] * sin(theta)
	c1 <- c[1] * cos(theta) + d[1] * sin(theta)
	ee <- sqrt(a1^2 + c1^2)
	phi <- atan2(c1, a1)
	for(i in 1:harmo) {
		mat <- matrix(c(a[i], b[i], c[i], d[i]), 2, 2, byrow=T)
		rot <- matrix(c(cos(phi), sin(phi), -sin(phi), cos(phi)), 2, 2, byrow=T)
		sif <- matrix(c(cos(i*theta), -sin(i*theta), sin(i*theta), cos(i*theta)), 2, 2, byrow=T)
		mat <- (1/ee) * rot %*% mat %*% sif
		na[i] <- mat[1,1]
		nb[i] <- mat[1,2]
		nc[i] <- mat[2,1]
		nd[i] <- mat[2,2]
	}
	list(a = na, b = nb, c = nc, d = nd)
}

turn <- function(ef)
{
	# 180x]
	harmo <- length(ef$a)
	if(length(ef$b) != harmo || length(ef$c) != harmo || length(ef$d) != harmo)
		stop("# of coefficients are not identical")
	na <- ef$a
	nb <- ef$b
	nc <- ef$c
	nd <- ef$d
	p <- seq(2, harmo, 2)
	na[p] <- -na[p]
	nb[p] <- -nb[p]
	nc[p] <- -nc[p]
	nd[p] <- -nd[p]
	list(a = na, b = nb, c = nc, d = nd)
}

